/*
    This file is part of HPerf.
    Copyright (C) 2020-2022  Laurent Poirrier

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published
    by the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#include "files.h"

#include "gen_base.css.h"
#include "gen_app.js.h"

static char file_base_css[] = GEN_BASE_CSS;
static char file_app_js[] = GEN_APP_JS;

int file_get(int id, char **content, size_t *size)
{
	switch(id) {
	case FILE_BASE_CSS:
		if (content)
			*content = file_base_css;
		if (size)
			*size = sizeof(file_base_css);
		
		return 0;
	
	case FILE_APP_JS:
		if (content)
			*content = file_app_js;
		if (size)
			*size = sizeof(file_app_js);
		
		return 0;
	
	default:
		return -1;
	
	}
}
